Package htsjdk.samtools

# Class Defaults

java.lang.Object
htsjdk.samtools.Defaults

public class Defaults extends Object
Embodies defaults for global values that affect how the SAM JDK operates. Defaults are encoded in the class and are also overridable using system properties.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`BUFFER_SIZE`
Buffer size, in bytes, used whenever reading/writing files or streams.
`static final int`
`COMPRESSION_LEVEL`
Compression level to be used for writing BAM and other block-compressed outputs.
`static final boolean`
`CREATE_INDEX`
Should BAM index files be created when writing out coordinate sorted BAM files? Default = false.
`static final boolean`
`CREATE_MD5`
Should MD5 files be created when writing out SAM and BAM files? Default = false.
`static final String`
`CUSTOM_READER_FACTORY`
Custom reader factory able to handle URL based resources like ga4gh.
`static final String`
`DEFAULT_SAM_EXTENSION`
The extension to assume a sam file has when the actual file doesn't have an extension, useful for when outputing to /dev/stdout, for example.
`static final String`
`DEFAULT_VCF_EXTENSION`
The extension to assume a vcf has when the actual file doesn't have an extension, useful for when outputing to /dev/stdout, for example.
`static final boolean`
`DISABLE_SNAPPY_COMPRESSOR`
Disable use of the Snappy compressor.
`static final String`
`DISABLE_SNAPPY_PROPERTY_NAME`
The name of the system property that disables snappy.
`static final String`
`EBI_REFERENCE_SERVICE_URL_MASK`
A mask (pattern) to use when building EBI reference service URL for a given MD5 checksum.
`static final int`
`NON_ZERO_BUFFER_SIZE`
Even if BUFFER_SIZE is 0, this is guaranteed to be non-zero.
`static final boolean`
`OPTIMISTIC_VCF_4_4`
`static final String`
`OPTIMISTIC_VCF_4_4_PROPERTY`
`static final File`
`REFERENCE_FASTA`
The reference FASTA file.
`static final SamFlagField`
`SAM_FLAG_FIELD_FORMAT`
The output format of the flag field when writing SAM text.
`static final String`
`SAMJDK_PREFIX`
`static final boolean`
`SRA_LIBRARIES_DOWNLOAD`
Boolean describing whether downloading of SRA native libraries is allowed, in case such native libraries are not found locally.
`static final boolean`
`USE_ASYNC_IO_READ_FOR_SAMTOOLS`
Should asynchronous read I/O be used where supported by the samtools package (one thread per file).
`static final boolean`
`USE_ASYNC_IO_WRITE_FOR_SAMTOOLS`
Should asynchronous write I/O be used where supported by the samtools package (one thread per file).
`static final boolean`
`USE_ASYNC_IO_WRITE_FOR_TRIBBLE`
Should asynchronous write I/O be used where supported by the tribble package (one thread per file).
`static final boolean`
`USE_CRAM_REF_DOWNLOAD`
Boolean describing whether downloading a reference file is allowed (for CRAM files), in case the reference file is not specified by the user Enabling this is not necessarily a good idea, since this process often fails.

## Constructor Summary

Constructors
Constructor
Description
`Defaults()`

## Method Summary

Modifier and Type
Method
Description
`static SortedMap<String,Object>`
`allDefaults()`
Returns a map of all default values (keys are names), lexicographically sorted by keys.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### CREATE_INDEX

public static final boolean CREATE_INDEX
Should BAM index files be created when writing out coordinate sorted BAM files? Default = false.

### CREATE_MD5

public static final boolean CREATE_MD5
Should MD5 files be created when writing out SAM and BAM files? Default = false.

### USE_ASYNC_IO_READ_FOR_SAMTOOLS

public static final boolean USE_ASYNC_IO_READ_FOR_SAMTOOLS
Should asynchronous read I/O be used where supported by the samtools package (one thread per file). Default = false.

### USE_ASYNC_IO_WRITE_FOR_SAMTOOLS

public static final boolean USE_ASYNC_IO_WRITE_FOR_SAMTOOLS
Should asynchronous write I/O be used where supported by the samtools package (one thread per file). Default = false.

### USE_ASYNC_IO_WRITE_FOR_TRIBBLE

public static final boolean USE_ASYNC_IO_WRITE_FOR_TRIBBLE
Should asynchronous write I/O be used where supported by the tribble package (one thread per file). Default = false.

### COMPRESSION_LEVEL

public static final int COMPRESSION_LEVEL
Compression level to be used for writing BAM and other block-compressed outputs. Default = 5.

### BUFFER_SIZE

public static final int BUFFER_SIZE
Buffer size, in bytes, used whenever reading/writing files or streams. Default = 128k.

### SAM_FLAG_FIELD_FORMAT

public static final SamFlagField SAM_FLAG_FIELD_FORMAT
The output format of the flag field when writing SAM text. Ignored for reading SAM text. Default = DECIMAL

### DEFAULT_SAM_EXTENSION

public static final String DEFAULT_SAM_EXTENSION
The extension to assume a sam file has when the actual file doesn't have an extension, useful for when outputing to /dev/stdout, for example.

### DEFAULT_VCF_EXTENSION

public static final String DEFAULT_VCF_EXTENSION
The extension to assume a vcf has when the actual file doesn't have an extension, useful for when outputing to /dev/stdout, for example.

### OPTIMISTIC_VCF_4_4

public static final boolean OPTIMISTIC_VCF_4_4

### NON_ZERO_BUFFER_SIZE

public static final int NON_ZERO_BUFFER_SIZE
Even if BUFFER_SIZE is 0, this is guaranteed to be non-zero. If BUFFER_SIZE is non-zero, this == BUFFER_SIZE (Default = 128k).

### REFERENCE_FASTA

public static final File REFERENCE_FASTA
The reference FASTA file. If this is not set, the file is null. This file may be required for reading writing SAM files (ex. CRAM). Default = null.

### CUSTOM_READER_FACTORY

public static final String CUSTOM_READER_FACTORY
Custom reader factory able to handle URL based resources like ga4gh. Expected format: <url prefix>,<fully qualified factory class name>[,<jar file name>] E.g. https://www.googleapis.com/genomics/v1beta/reads/,com.google.genomics.ReaderFactory OR https://www.googleapis.com/genomics/v1beta/reads/,com.google.genomics.ReaderFactory,/tmp/genomics.jar Default = "".

### USE_CRAM_REF_DOWNLOAD

public static final boolean USE_CRAM_REF_DOWNLOAD
Boolean describing whether downloading a reference file is allowed (for CRAM files), in case the reference file is not specified by the user Enabling this is not necessarily a good idea, since this process often fails. Default = false.

### EBI_REFERENCE_SERVICE_URL_MASK

public static final String EBI_REFERENCE_SERVICE_URL_MASK
A mask (pattern) to use when building EBI reference service URL for a given MD5 checksum. Must contain one and only one string placeholder. Default = "https://www.ebi.ac.uk/ena/cram/md5/%s".

### SRA_LIBRARIES_DOWNLOAD

public static final boolean SRA_LIBRARIES_DOWNLOAD
Boolean describing whether downloading of SRA native libraries is allowed, in case such native libraries are not found locally. Default = false.

### DISABLE_SNAPPY_PROPERTY_NAME

public static final String DISABLE_SNAPPY_PROPERTY_NAME
The name of the system property that disables snappy. Default = "snappy.disable".

See Also:
  - Constant Field Values

### OPTIMISTIC_VCF_4_4_PROPERTY

public static final String OPTIMISTIC_VCF_4_4_PROPERTY

See Also:
  - Constant Field Values

### DISABLE_SNAPPY_COMPRESSOR

public static final boolean DISABLE_SNAPPY_COMPRESSOR
Disable use of the Snappy compressor. Default = false.

### SAMJDK_PREFIX

public static final String SAMJDK_PREFIX

See Also:
  - Constant Field Values

## Constructor Details

### Defaults

public Defaults()

## Method Details

### allDefaults

public static SortedMap<String,Object> allDefaults()
Returns a map of all default values (keys are names), lexicographically sorted by keys. The returned map is unmodifiable. This function is useful for example when logging all defaults.